;/*
;--------------------------------------------------------------------------------------------------  
;Usage:
;
;/socket [-cfpx] <name> <location>:[Port] [Page to GET/POST] [Filename.txt]
;
;The -c switch closes socket <name>, <location> not necesary with -c.
;
;The -f switch will save the results to file [Filename.txt]  If -f is not specified, the feed will be
;echoed to the status window.
;
;The -p switch specifies to use POST.  Default GET will be used if -p switch is not present.
;
;The -x switch tells the script to remove html codes.
;
;Note:[Filename.txt] only necesary with -f.
;
;Note: Don't put spaces between the different switches.  Example: /socket -cpx (...) is correct.
;
;Note: If you use -f, you must specify the full path of the file, no matter what directory it is in.  If 
;you don't, the filename maybe interpreted as the page to GET.
;Ex: /socket -f sckt mirc.net savefile.txt    will make the script try to find "savefile.txt" on the 
;mirc.net server.
;
;Snippet created by tech_9
;Questions or comments can be sent to andrew.asche-at-gmail-dot-com
;If you email me, put "/socket" or something similar as the subject, or I will assume your email is spam
;and delete it.
;
;A HUGE thanks goes out to Tye for not only putting up wtih my newbie questions for several hours, 
;but also for helping me write all the parts I couldn't figure out how to do.
;
;You can edit this script for your own needs.  If you change fewer than 30 lines of code, I would
;appreciate it if you gave some credit.  =)  Thanks.
;
;
;Changes:
;-Port is now attached to location
;-Filenames can contain spaces
;-May supply only 1 optional parameter
;-Added error checking
;--------------------------------------------------------------------------------------------------
;*/

alias socket {  
  if ( $mid($1, 1, 1) != - ) {
    if ( : isin $2 ) { 
      set %sloc $mid($2, 1, $calc( $pos($2, :, 1) - 1 ))
      set %sport $mid($2, $calc($pos($2, :, 1) + 1), $calc( $len($2) - $pos($2, :, 1)))
      if (($len(%sport) < 1) || (%sport == 0)) { /echo -s Invalid Port Number, default used. | /set %sport 80 }
    }
    else { /set %sloc $2 }
    if (%sport == $null) { /set %sport 80 }
    set %sname $1
    set %star $3     
    if (( %star == $null ) || ( $mid(%star, 1, 1) != "/" )) { /set %star / $+ %star }
    set %soriginal $true  
    sockopen $1 %sloc %sport
  }
  elseif ( $mid($1, 1, 1) == - ) {  
    if ( : isin $3 ) { 
      set %sloc $mid($3, 1, $calc( $pos($3, :, 1) - 1 ))
      set %sport $mid($3, $calc($pos($3, :, 1) + 1), $calc( $len($3) - $pos($3, :, 1)))
      if ($len(%sport) < 1) { /echo -s Invalid Port Number, default used. | /set %sport 80 }
    }
    else { /set %sloc $3 }    
    if (%sport == $null) { /set %sport 80 }
    set %sname $2
    if ($mid($4, 1, 2) != C: ) { /set %star $4 }
    set %ssw $calc( $len($1) - 1)
    var %x = 1 | while (%x <= 4) { 
      var %scu = $mid($mid($1, 2, %ssw),%x,1) 
      var %x = $calc( %x + 1) 
      if (%scu == c) { /set %sname $2 | /set %sclose $true }
      if (%scu == f) {
        set %sfile $true
        if (%star == $null) { /set %spath $4- }
        else { /set %spath $5- }
      }
      if (%scu == p) { /set %spost $true }    
      if (%scu == x) { /set %sstrip $true }
      set %soriginal $false
    }  
  }
  socket.init  
}

alias -l htmlfree {
  var %x, %i = $regsub($1-,/(^[^<]*>|<[^>]*>|<[^>]*$)/g,$null,%x), %x = $remove(%x,&nbsp;)
  return %x
}

on 1:sockclose:*:{
  /echo -s %sname closed remotely
  unset %sname %sloc %star %sport %ssw %sfile %spath %soriginal %sstrip %spost
}

on 1:sockopen:*:{
  if (%spost != $true) {
    sockwrite -n %sname GET %star HTTP/1.1
    sockwrite -n %sname Host: %sloc $+ $crlf $+ $crlf
    echo -s Reading from %sname
  }
  else {
    sockwrite -n %sname POST %star HTTP/1.1
    sockwrite -n %sname Host: %sloc $+ $crlf $+ $crlf
    echo -s Reading from %sname
  }
}

On *:sockread:*:{
  if (%sfile != $true) {
    if ($sockerr) { /echo -s Error }
    else {
      var %temptext
      sockread %temptext
      if (%sstrip == $true) { if ($htmlfree(%temptext) != $null) { /echo -s $htmlfree(%temptext) } }
      else { /echo -s %temptext }
    } 
  }
  else {
    if ($sockerr) { /echo -s Error... }
    else {
      if ($mid(%spath, 1, 2) != C: ) { /echo -s Invalid file path.  Remember to use FULL file path. | /halt }    
      set %spath $shortfn($nofile(%spath)) $+ $nopath(%spath)
      var %temptext
      sockread %temptext
      if (%sstrip == $true) { /write %spath $htmlfree(%temptext) }
      else { /write %spath %temptext }    
    }
  }
}


alias -l socket.close {
  echo -s Closed %sname 
  sockclose %sname
  unset %sname %sloc %star %sport %ssw %sfile %spath %soriginal %sstrip %spost %sclose
  halt
}

alias -l socket.init {
  if (%soriginal == $true) { /return }
  if (%sclose == $true) { /socket.close }
  sockopen %sname %sloc %sport  
  if (( %star == $null ) || ( $mid(%star, 1, 1) != "/" )) { /set %star / $+ %star }
}
